"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _effects = require("redux-saga/effects");

var _actions = require("./actions");

var _action_types = require("./action_types");

var unsubscribeViewModelTopicsSaga =
/*#__PURE__*/
_regenerator["default"].mark(function unsubscribeViewModelTopicsSaga(_ref) {
  var viewModels, viewModelName, aggregateIds, viewModel, eventTypes, subscriptionKeys, counter, _iterator, _isArray, _i, _ref4, _ref5, aggregateId, eventType, _loop;

  return _regenerator["default"].wrap(function unsubscribeViewModelTopicsSaga$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          viewModels = _ref.viewModels, viewModelName = _ref.viewModelName, aggregateIds = _ref.aggregateIds;
          viewModel = viewModels.find(function (_ref2) {
            var name = _ref2.name;
            return name === viewModelName;
          });
          eventTypes = Object.keys(viewModel.projection).filter(function (eventType) {
            return eventType !== 'Init';
          });
          subscriptionKeys = eventTypes.reduce(function (acc, eventType) {
            if (Array.isArray(aggregateIds)) {
              acc.push.apply(acc, aggregateIds.map(function (aggregateId) {
                return {
                  aggregateId: aggregateId,
                  eventType: eventType
                };
              }));
            } else if (aggregateIds === '*') {
              acc.push({
                aggregateId: '*',
                eventType: eventType
              });
            }

            return acc;
          }, []);

        case 4:
          if (!(subscriptionKeys.length > 0)) {
            _context2.next = 30;
            break;
          }

          counter = subscriptionKeys.length;
          _iterator = subscriptionKeys, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();

        case 7:
          if (!_isArray) {
            _context2.next = 13;
            break;
          }

          if (!(_i >= _iterator.length)) {
            _context2.next = 10;
            break;
          }

          return _context2.abrupt("break", 23);

        case 10:
          _ref4 = _iterator[_i++];
          _context2.next = 17;
          break;

        case 13:
          _i = _iterator.next();

          if (!_i.done) {
            _context2.next = 16;
            break;
          }

          return _context2.abrupt("break", 23);

        case 16:
          _ref4 = _i.value;

        case 17:
          _ref5 = _ref4;
          aggregateId = _ref5.aggregateId, eventType = _ref5.eventType;
          _context2.next = 21;
          return (0, _effects.put)((0, _actions.unsubscribeTopicRequest)(eventType, aggregateId));

        case 21:
          _context2.next = 7;
          break;

        case 23:
          _loop =
          /*#__PURE__*/
          _regenerator["default"].mark(function _loop() {
            var unsubscribeResultAction;
            return _regenerator["default"].wrap(function _loop$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    _context.next = 2;
                    return (0, _effects.take)( // eslint-disable-next-line no-loop-func
                    function (action) {
                      return (action.type === _action_types.UNSUBSCRIBE_TOPIC_SUCCESS || action.type === _action_types.UNSUBSCRIBE_TOPIC_FAILURE) && subscriptionKeys.find(function (key) {
                        return key.aggregateId === action.topicId && key.eventType === action.topicName;
                      });
                    });

                  case 2:
                    unsubscribeResultAction = _context.sent;

                    if (unsubscribeResultAction.type === _action_types.UNSUBSCRIBE_TOPIC_SUCCESS) {
                      subscriptionKeys = subscriptionKeys.filter(function (key) {
                        return !(key.aggregateId === unsubscribeResultAction.topicId && key.eventType === unsubscribeResultAction.topicName);
                      });
                    }

                    counter--;

                  case 5:
                  case "end":
                    return _context.stop();
                }
              }
            }, _loop);
          });

        case 24:
          if (!(counter > 0)) {
            _context2.next = 28;
            break;
          }

          return _context2.delegateYield(_loop(), "t0", 26);

        case 26:
          _context2.next = 24;
          break;

        case 28:
          _context2.next = 4;
          break;

        case 30:
        case "end":
          return _context2.stop();
      }
    }
  }, unsubscribeViewModelTopicsSaga);
});

var _default = unsubscribeViewModelTopicsSaga;
exports["default"] = _default;
//# sourceMappingURL=unsubscribe_view_model_topics_saga.js.map